From 27d1e6ebd84515465c2fe70f664048124fcf3681 Mon Sep 17 00:00:00 2001
From: James Coleman <jtc331@gmail.com>
Date: Sat, 28 Mar 2020 20:04:03 -0400
Subject: [PATCH v45 6/7] fix inc sort enabled check

---
 src/backend/optimizer/path/allpaths.c | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 480803fb7a..93d967e812 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -2818,10 +2818,6 @@ generate_useful_gather_paths(PlannerInfo *root, RelOptInfo *rel, bool override_r
 	/* generate the regular gather (merge) paths */
 	generate_gather_paths(root, rel, override_rows);
 
-	/* when incremental sort is disabled, we're done */
-	if (!enable_incrementalsort)
-		return;
-
 	/* consider incremental sort for interesting orderings */
 	useful_pathkeys_list = get_useful_pathkeys_for_relation(root, rel);
 
@@ -2911,7 +2907,7 @@ generate_useful_gather_paths(PlannerInfo *root, RelOptInfo *rel, bool override_r
 			 * Consider incremental sort, but only when the subpath is already
 			 * partially sorted on a pathkey prefix.
 			 */
-			if (presorted_keys > 0)
+			if (enable_incrementalsort && presorted_keys > 0)
 			{
 				Path	   *tmp;
 
-- 
2.17.1

